
package de.ivu.elect.presentation.staat.exchange;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractImporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.staat.boundary.StaatenGruppeImporter;
import de.ivu.elect.business.staat.control.StaatenGruppeImportContext;
import de.ivu.elect.business.staat.entity.StaatenGruppe;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractImportBestaetigenView;
import de.ivu.elect.presentation.exchange.ImportDescription;

@Named(StaatenGruppeImportBestaetigenView.COMPONENT_NAME)
@View(viewId = StaatenGruppeImportBestaetigenView.VIEW_ID, useCase = UseCasePermission.STAATEN_GRUPPE_IMPORTIEREN)
public class StaatenGruppeImportBestaetigenView extends AbstractImportBestaetigenView<List<StaatenGruppe>, StaatenGruppeImportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatenGruppeImportBestaetigenView";

  public static final String VIEW_ID = "/staat/staaten-gruppe-import-bestaetigen.xhtml";

  @Inject
  private transient StaatenGruppeImporter staatenGruppeImporter;

  @Inject
  private transient StaatenGruppeImportDescription staatenGruppeImportDescription;

  public StaatenGruppeImportBestaetigenView() {
    super();
  }

  @Override
  protected AbstractImporter<List<StaatenGruppe>, StaatenGruppeImportContext, ? > getImporter() {
    return staatenGruppeImporter;
  }

  @Override
  protected StaatenGruppeImportContext getContext() {
    if (isWahlSelected()) {
      return new StaatenGruppeImportContext(getSelectedWahl());
    }

    return new StaatenGruppeImportContext(getSelectedWahltermin());
  }

  @Override
  protected ImportDescription getImportDescription() {
    return staatenGruppeImportDescription;
  }
}
